#include <libxml/parser.h>   // usually in /usr/include/libxml2, see xml2-config

#include "String.h"

class xml_node
{
   xmlNodePtr     n;

public:

   xml_node()
   {
      n = NULL;
   }

   xml_node(xmlNodePtr np)
   {
      n = np;
   }

   bool is_a_node(void)
   {
      return n != NULL;
   }

   String name(void)
   {
      String node_name;

      if (n != NULL)
      {
         node_name = String((const char *)n->name);
      }

      return node_name;
   }

   // Assumes one childnode of type TEXT
   // TODO collect content from multiple TEXT nodes (recursively ?)
   String content(void)
   {
      String node_content;

      if (n != NULL)
      {
         node_content = String((const char *)n->children->content);
      }

      return node_content;
   }

   //  Find the nth child element by name (non-recursive)
   xml_node FindChildElement(String name, int nth = 0);
};

class xml
{
   xmlDocPtr      document;

public:

   xml()
   {
      document = NULL;
   }

   ~xml()
   {
      if (document != NULL)
      {
         xmlFreeDoc(document);
         document = NULL;
      }
   }

   void ParseFile(const char * filename)
   {
      document = xmlParseFile(filename);
   }

   void SaveFile(const char * filename)
   {
      xmlSaveFile(filename, document);
   }

   String RootElementName(void);
   xml_node RootNode(void);
  
};

