/*******************************************************
 *  Unit test for the date class
 *
 * test contrustor and assignment of Sting objects
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   // Default contructor: all zero
   date d0;

   std::cout << "The default contructor makes a zero date: \"" << d0 << "\"\n";
   assert(d0.Day() == 0);
   assert(d0.Month() == 0);
   assert(d0.Year() == 0);

   // Constructors with default arguments
   date d1(5);

   std::cout << "Contructor with just day = 5: \"" << d1 << "\"\n";
   assert(d1.Day() == 5);
   assert(d1.Month() == 0);
   assert(d1.Year() == 0);

   date d2(10, 7);

   std::cout << "Contructor with just day = 10 and month = 7: \"" << d2 << "\"\n";
   assert(d2.Day() == 10);
   assert(d2.Month() == 7);
   assert(d2.Year() == 0);

   date d3(15, 9, 2002);

   std::cout << "Contructor with day = 15 month = 9, and year = 2002: \"" << d3 << "\"\n";
   assert(d3.Day() == 15);
   assert(d3.Month() == 9);
   assert(d3.Year() == 2002);

   date d4(88, 55, 1000);

   std::cout << "Contructor with day = 88 month = 55, and year = 1000: \"" << d4 << "\"\n";
   assert(d4.Day() == 88);
   assert(d4.Month() == 55);
   assert(d4.Year() == 1000);

   // The copy constructor is just a bitwise copy

   date d5(d3);

   std::cout << "Copy contructor from day = 15 month = 9, and year = 2002: \"" << d5 << "\"\n";
   assert(d5.Day() == 15);
   assert(d5.Month() == 9);
   assert(d5.Year() == 2002);

   // Also assignment is just a bitwise copy

   date d6;

   d6 = d3;
   std::cout << "Assigned from day = 15 month = 9, and year = 2002: \"" << d6 << "\"\n";
   assert(d6.Day() == 15);
   assert(d6.Month() == 9);
   assert(d6.Year() == 2002);

   return 0;
}

