/*******************************************************
 *  Unit test for the Integer class
 *
 * test contrustor and assignment of Integer objects
 ******************************************************
 *
 */

#include "Integer.h"
#include <assert.h>

int main()
{
   // Default contructor: all zero
   Integer i0;

   std::cout << "The default contructor makes a zero number: \"" << i0 << "\"\n";
   std::cout.flush();
   assert(i0 == 0);

   // Constructors with a literal value
   Integer i1(5);

   std::cout << "Contructor with a number = 5: \"" << i1 << "\"\n";
   std::cout.flush();
   assert(i1 == 5);

   // Initializer with a literal value
   Integer i2 = 42;

   std::cout << "Initializer with a number = 42: \"" << i2 << "\"\n";
   std::cout.flush();
   assert(i2 == 42);

   // Assignment of a literal value
   Integer i3;
   i3 = 123;

   std::cout << "Assignment with a number = 123: \"" << i3 << "\"\n";
   std::cout.flush();
   assert(i3 == 123);

   // Contructor with an Integer object
   Integer i4(i2);

   std::cout << "Contructor with Integer: \"" << i4 << "\"\n";
   std::cout.flush();
   assert(i4 == i2);

   // Assignment of a Integer object
   Integer i5;
   i5 = i3;

   std::cout << "Assignment with Integer: \"" << i5 << "\"\n";
   std::cout.flush();
   assert(i5 == i3);

   return 0;
}

