/*******************************************************
 *  Unit test for the String class
 *
 * test substring operations
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // Default contructor: empty string
   String s0;

   // Select a substring
   String s1 = "abcdefghijkl";
   String s2 = s1(3,5);         // s2 = "defgh"

   std::cout << "The substring (3,5) of " << s1 << " is " << s2 << "\n";
   assert(s2 == "defgh");

   String s3 = "abcdefghijkl";
   String s4 = "12345678";

   std::cout << "Replace substring (3,5) of " << s3 << " with " << s4 << " : ";
   s3(3,5) = s4;           // s3 = "abc12345678ijkl"
   std::cout << s3 << "\n";
   assert(s3 == "abc12345678ijkl");

   String s5 = "abcdefghijkl";
   String s6 = "12345678";

   std::cout << "Insert \"" << s6 << "\" into \"" << s5 << "\" : ";
   s5(3, 0) = s6;
   std::cout << s5 << "\n";
   assert(s5 == "abc12345678defghijkl");

   std::cout << "Remove part of \"" << s5 << "\" : ";
   s5(11,5) = "";
   std::cout << s5 << "\n";
   assert(s5 == "abc12345678ijkl");

   // Select a substring out of bounds
   try
   {
      String s7 = "abcdefghijkl";
      String s8 = s7(9,5);         // s7 = "jkl.."

      std::cout << "The substring (9,5) of " << s7 << " is " << s8 << "\n";
   }
   catch (StringException se)
   {
      std::cout << "String exception: " << se.what() << "\n";
   }

   //assert(s2 == "defgh");

   return 0;
}

